unit uAlphaForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls, ComCtrls;

type
  TAlphaForm = class(TForm)
    pnlAlpha: TPanel;
    tkbarAlpha: TTrackBar; 
    procedure tkbarAlphaChange(Sender: TObject);
  private
    { Private declarations }
    BlendAlpha:Byte;
    procedure SetBlendAlpha(Value:Byte);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    property byteAlpha:Byte read BlendAlpha write SetBlendAlpha default 255;
  protected
    {Asscessable only for This Class and derived Class}
  published
    //property byteAlpha:Byte read BlendAlpha write SetBlendAlpha default 255;
  end;


const
  WS_EX_LAYERED = $00080000;
  LWA_ALPHA = $00000002;

type
  FAnimateWindow = function(const hwnd: HWND; const dwTime: DWORD; const dwFlags: DWORD):DWORD; stdcall;
  FSetLayeredWindowAttributes = function(hWnd: HWND; crKey: DWORD; bAlpha: Byte; dwFlags: DWORD): BOOL; stdcall;


function AnimateWindow(const hwnd: HWND; const dwTime: DWORD; const dwFlags: DWORD):DWORD;
function SetLayeredWindowAttributes(hwnd: HWND; crKey: DWORD; bAlpha: Byte; dwFlags: DWord): BOOL;

var
  AlphaForm: TAlphaForm;

implementation

{$R *.DFM}

function AnimateWindow(const hwnd: HWND; const dwTime: DWORD; const dwFlags: DWORD):DWORD;
var
  DLLHandle : THandle;
  AnimateWindow : FAnimateWindow;
begin
  Result := 0;
  DLLHandle := LoadLibrary('user32.dll');
  if DLLHandle <> 0 then begin
    @AnimateWindow := GetProcAddress(DLLHandle,'AnimateWindow');
    if @AnimateWindow <> nil then begin
      Result := AnimateWindow(hwnd,dwTime,dwFlags);
    end;
  end;
end;

function SetLayeredWindowAttributes(hwnd: HWND; crKey: DWORD; bAlpha: Byte; dwFlags: DWORD): BOOL;
var
  DLLHandle : THandle;
  gwlStyle : Longint;
  SetLayeredWindowAttributes : FSetLayeredWindowAttributes;
begin
  Result := false;
  DLLHandle := LoadLibrary('user32.dll');
  if DLLHandle <> 0 then begin
    @SetLayeredWindowAttributes := GetProcAddress(DLLHandle,'SetLayeredWindowAttributes');
    if @SetLayeredWindowAttributes <> nil then begin
      gwlStyle := GetWindowLong(hwnd,GWL_EXSTYLE);
      gwlStyle := gwlStyle or WS_EX_LAYERED;
      SetWindowLong(hwnd,GWL_EXSTYLE,gwlStyle);
      Result := SetLayeredWindowAttributes(hWnd,crKey,bAlpha,dwFlags);
    end;
  end;
end;


constructor TAlphaForm.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  byteAlpha:=250;
end;

procedure TAlphaForm.tkbarAlphaChange(Sender: TObject);
begin
  byteAlpha:=tkbarAlpha.Position;
end;


procedure TAlphaForm.SetBlendAlpha(Value:Byte);
begin
  if Value<>BlendAlpha then
  begin
    BlendAlpha:=Value;
    tkbarAlpha.Position:=BlendAlpha;   
    SetLayeredWindowAttributes(Handle,0,BlendAlpha,LWA_ALPHA);
  end;
end;


end.
